const button = document.querySelector("input[type=button]");
const text = document.querySelector("input[type=text]");
const div = document.getElementById("anagrams");
button.addEventListener("click", e => {
    e.preventDefault();
    const chars = text.value.split("");
    // console.log(chars);
    // console.log(chars.sort().join(""));
    const res = [];
    generate(chars.length, chars, res);
    let output = "";
    res.forEach(r=>{
        output += `${r} <br/>`; 
    });
    div.innerHTML += output;
    
}, false);

function swap(chars, i, j) {
    var tmp = chars[i];
    chars[i] = chars[j];
    chars[j] = tmp;
}

// Heap's algorithm https://en.wikipedia.org/wiki/Heap's_algorithm
function generate(k, chars, res){
    if(k === 1){
        res.push(chars.join(""));
        return;
    }

    generate(k-1, chars, res);

    for(let i=0; i<k-1; i++){
        if(k%2===0){
            swap(chars, i, k-1);
        } else {
            swap(chars, 0, k-1);
        }
        generate(k-1, chars, res);
    }
}